#!/usr/bin/python
# -*- coding: utf-8 -*-
# MIT License, Copyright (c) 2024, Damien Andre, Limoges University

"""
This script plots spherical histograms. The rendering is given by mayavi.
The idea behind the algorithm is quite simple.
1/ first, a geodesic geometry is built. This geometry fits a (quasi) sphere with equal triangles.
2/ random direction (called rays in the script) are randomly pick. Note that you must skip process with your own data !
3/ for each direction, a detection algorithm is used to detect the geodesic triangle which is intersected.
4/ the number of intersection are counted and the geode's triangles are rendered and scaled based on the number of intersection
--
Just a note about random picking : as you can see, the method which is used here is not able to render perfect uniform distribution
in a spherical space ! but this is another story :-)
"""

import numpy as np
import sys
from mayavi import mlab
from tvtk.tools import visual

def ray_triangle_intersect(r, v0, v1, v2):
    v0v1 = v1 - v0
    v0v2 = v2 - v0
    pvec = np.cross(r, v0v2)
    det = v0v1.dot(pvec)
    if det < 0.000001:
        return float('-inf')

    invDet = 1.0 / det
    tvec = - v0
    u = np.dot(tvec,pvec) * invDet
    if u < 0 or u > 1:
        return float('-inf')

    qvec = np.cross(tvec,v0v1)
    v = np.dot(r, qvec) * invDet
    if v < 0 or u + v > 1:
        return float('-inf')

    return np.dot(v0v2, qvec) * invDet


# this geometry is made of equal triangles
# that forms a quasi-sphere 
GEODESIC_STR="""OFF
162 320 0
0.850651 0.525731 0
-0.850651 0.525731 0
-0.850651 -0.525731 0
0.850651 -0.525731 0
0.525731 0 0.850651
0.525731 0 -0.850651
-0.525731 0 -0.850651
-0.525731 0 0.850651
0 0.850651 0.525731
0 -0.850651 0.525731
0 -0.850651 -0.525731
0 0.850651 -0.525731
0.309017 0.5 0.809017
-0.309017 0.5 0.809017
0 0 1
-0.309017 -0.5 0.809017
0.309017 -0.5 0.809017
0 0 -1
-0.309017 0.5 -0.809017
0.309017 0.5 -0.809017
0.309017 -0.5 -0.809017
-0.309017 -0.5 -0.809017
0.809017 0.309017 0.5
0.809017 -0.309017 0.5
1 0 0
0.809017 -0.309017 -0.5
0.809017 0.309017 -0.5
-0.809017 -0.309017 0.5
-0.809017 0.309017 0.5
-1 0 0
-0.809017 0.309017 -0.5
-0.809017 -0.309017 -0.5
0.5 0.809017 0.309017
0.5 0.809017 -0.309017
0 1 0
-0.5 0.809017 -0.309017
-0.5 0.809017 0.309017
0 -1 0
0.5 -0.809017 -0.309017
0.5 -0.809017 0.309017
-0.5 -0.809017 0.309017
-0.5 -0.809017 -0.309017
0.433889 0.259892 0.862669
0.16246 0.262866 0.951057
0.273266 0 0.961938
0 0.525731 0.850651
-0.16246 0.262866 0.951057
-0.433889 0.259892 0.862669
-0.273266 0 0.961938
0.160622 0.702046 0.69378
-0.160622 0.702046 0.69378
0.16246 -0.262866 0.951057
0.433889 -0.259892 0.862669
-0.16246 -0.262866 0.951057
0 -0.525731 0.850651
-0.160622 -0.702046 0.69378
0.160622 -0.702046 0.69378
-0.433889 -0.259892 0.862669
0.273266 0 -0.961938
0.16246 0.262866 -0.951057
0.433889 0.259892 -0.862669
-0.16246 0.262866 -0.951057
0 0.525731 -0.850651
-0.160622 0.702046 -0.69378
0.160622 0.702046 -0.69378
-0.273266 0 -0.961938
-0.433889 0.259892 -0.862669
0.433889 -0.259892 -0.862669
0.16246 -0.262866 -0.951057
0 -0.525731 -0.850651
-0.16246 -0.262866 -0.951057
-0.433889 -0.259892 -0.862669
0.160622 -0.702046 -0.69378
-0.160622 -0.702046 -0.69378
0.862669 0.433889 0.259892
0.951057 0.16246 0.262866
0.961938 0.273266 0
0.850651 0 0.525731
0.951057 -0.16246 0.262866
0.862669 -0.433889 0.259892
0.961938 -0.273266 0
0.69378 0.160622 0.702046
0.69378 -0.160622 0.702046
0.951057 0.16246 -0.262866
0.862669 0.433889 -0.259892
0.951057 -0.16246 -0.262866
0.850651 0 -0.525731
0.69378 -0.160622 -0.702046
0.69378 0.160622 -0.702046
0.862669 -0.433889 -0.259892
-0.862669 -0.433889 0.259892
-0.951057 -0.16246 0.262866
-0.961938 -0.273266 0
-0.850651 0 0.525731
-0.951057 0.16246 0.262866
-0.862669 0.433889 0.259892
-0.961938 0.273266 0
-0.69378 -0.160622 0.702046
-0.69378 0.160622 0.702046
-0.951057 -0.16246 -0.262866
-0.862669 -0.433889 -0.259892
-0.951057 0.16246 -0.262866
-0.850651 0 -0.525731
-0.69378 0.160622 -0.702046
-0.69378 -0.160622 -0.702046
-0.862669 0.433889 -0.259892
0.259892 0.862669 0.433889
0.262866 0.951057 0.16246
0 0.961938 0.273266
0.525731 0.850651 0
0.262866 0.951057 -0.16246
0.259892 0.862669 -0.433889
0 0.961938 -0.273266
0.702046 0.69378 0.160622
0.702046 0.69378 -0.160622
-0.262866 0.951057 0.16246
-0.259892 0.862669 0.433889
-0.262866 0.951057 -0.16246
-0.525731 0.850651 0
-0.702046 0.69378 -0.160622
-0.702046 0.69378 0.160622
-0.259892 0.862669 -0.433889
0 -0.961938 0.273266
0.262866 -0.951057 0.16246
0.259892 -0.862669 0.433889
0.262866 -0.951057 -0.16246
0.525731 -0.850651 0
0.702046 -0.69378 -0.160622
0.702046 -0.69378 0.160622
0 -0.961938 -0.273266
0.259892 -0.862669 -0.433889
-0.259892 -0.862669 0.433889
-0.262866 -0.951057 0.16246
-0.525731 -0.850651 0
-0.262866 -0.951057 -0.16246
-0.259892 -0.862669 -0.433889
-0.702046 -0.69378 0.160622
-0.702046 -0.69378 -0.160622
0.425325 0.688191 0.587785
0.587785 0.425325 0.688191
0.688191 0.587785 0.425325
0.425325 0.688191 -0.587785
0.688191 0.587785 -0.425325
0.587785 0.425325 -0.688191
0.587785 -0.425325 0.688191
0.425325 -0.688191 0.587785
0.688191 -0.587785 0.425325
0.587785 -0.425325 -0.688191
0.688191 -0.587785 -0.425325
0.425325 -0.688191 -0.587785
-0.587785 0.425325 0.688191
-0.425325 0.688191 0.587785
-0.688191 0.587785 0.425325
-0.587785 0.425325 -0.688191
-0.688191 0.587785 -0.425325
-0.425325 0.688191 -0.587785
-0.587785 -0.425325 0.688191
-0.688191 -0.587785 0.425325
-0.425325 -0.688191 0.587785
-0.587785 -0.425325 -0.688191
-0.425325 -0.688191 -0.587785
-0.688191 -0.587785 -0.425325
3 4 42 44
3 44 42 43
3 44 43 14
3 42 12 43
3 14 43 46
3 46 43 45
3 46 45 13
3 43 12 45
3 14 46 48
3 48 46 47
3 48 47 7
3 46 13 47
3 12 49 45
3 45 49 50
3 45 50 13
3 49 8 50
3 4 44 52
3 52 44 51
3 52 51 16
3 44 14 51
3 16 51 54
3 54 51 53
3 54 53 15
3 51 14 53
3 16 54 56
3 56 54 55
3 56 55 9
3 54 15 55
3 14 48 53
3 53 48 57
3 53 57 15
3 48 7 57
3 5 58 60
3 60 58 59
3 60 59 19
3 58 17 59
3 19 59 62
3 62 59 61
3 62 61 18
3 59 17 61
3 19 62 64
3 64 62 63
3 64 63 11
3 62 18 63
3 17 65 61
3 61 65 66
3 61 66 18
3 65 6 66
3 5 67 58
3 58 67 68
3 58 68 17
3 67 20 68
3 17 68 70
3 70 68 69
3 70 69 21
3 68 20 69
3 17 70 65
3 65 70 71
3 65 71 6
3 70 21 71
3 20 72 69
3 69 72 73
3 69 73 21
3 72 10 73
3 0 74 76
3 76 74 75
3 76 75 24
3 74 22 75
3 24 75 78
3 78 75 77
3 78 77 23
3 75 22 77
3 24 78 80
3 80 78 79
3 80 79 3
3 78 23 79
3 22 81 77
3 77 81 82
3 77 82 23
3 81 4 82
3 0 76 84
3 84 76 83
3 84 83 26
3 76 24 83
3 26 83 86
3 86 83 85
3 86 85 25
3 83 24 85
3 26 86 88
3 88 86 87
3 88 87 5
3 86 25 87
3 24 80 85
3 85 80 89
3 85 89 25
3 80 3 89
3 2 90 92
3 92 90 91
3 92 91 29
3 90 27 91
3 29 91 94
3 94 91 93
3 94 93 28
3 91 27 93
3 29 94 96
3 96 94 95
3 96 95 1
3 94 28 95
3 27 97 93
3 93 97 98
3 93 98 28
3 97 7 98
3 2 92 100
3 100 92 99
3 100 99 31
3 92 29 99
3 31 99 102
3 102 99 101
3 102 101 30
3 99 29 101
3 31 102 104
3 104 102 103
3 104 103 6
3 102 30 103
3 29 96 101
3 101 96 105
3 101 105 30
3 96 1 105
3 8 106 108
3 108 106 107
3 108 107 34
3 106 32 107
3 34 107 110
3 110 107 109
3 110 109 33
3 107 32 109
3 34 110 112
3 112 110 111
3 112 111 11
3 110 33 111
3 32 113 109
3 109 113 114
3 109 114 33
3 113 0 114
3 8 108 116
3 116 108 115
3 116 115 36
3 108 34 115
3 36 115 118
3 118 115 117
3 118 117 35
3 115 34 117
3 36 118 120
3 120 118 119
3 120 119 1
3 118 35 119
3 34 112 117
3 117 112 121
3 117 121 35
3 112 11 121
3 9 122 124
3 124 122 123
3 124 123 39
3 122 37 123
3 39 123 126
3 126 123 125
3 126 125 38
3 123 37 125
3 39 126 128
3 128 126 127
3 128 127 3
3 126 38 127
3 37 129 125
3 125 129 130
3 125 130 38
3 129 10 130
3 9 131 122
3 122 131 132
3 122 132 37
3 131 40 132
3 37 132 134
3 134 132 133
3 134 133 41
3 132 40 133
3 37 134 129
3 129 134 135
3 129 135 10
3 134 41 135
3 40 136 133
3 133 136 137
3 133 137 41
3 136 2 137
3 8 49 106
3 106 49 138
3 106 138 32
3 49 12 138
3 32 138 140
3 140 138 139
3 140 139 22
3 138 12 139
3 32 140 113
3 113 140 74
3 113 74 0
3 140 22 74
3 12 42 139
3 139 42 81
3 139 81 22
3 42 4 81
3 11 111 64
3 64 111 141
3 64 141 19
3 111 33 141
3 19 141 143
3 143 141 142
3 143 142 26
3 141 33 142
3 19 143 60
3 60 143 88
3 60 88 5
3 143 26 88
3 33 114 142
3 142 114 84
3 142 84 26
3 114 0 84
3 4 52 82
3 82 52 144
3 82 144 23
3 52 16 144
3 23 144 146
3 146 144 145
3 146 145 39
3 144 16 145
3 23 146 79
3 79 146 128
3 79 128 3
3 146 39 128
3 16 56 145
3 145 56 124
3 145 124 39
3 56 9 124
3 5 87 67
3 67 87 147
3 67 147 20
3 87 25 147
3 20 147 149
3 149 147 148
3 149 148 38
3 147 25 148
3 20 149 72
3 72 149 130
3 72 130 10
3 149 38 130
3 25 89 148
3 148 89 127
3 148 127 38
3 89 3 127
3 7 47 98
3 98 47 150
3 98 150 28
3 47 13 150
3 28 150 152
3 152 150 151
3 152 151 36
3 150 13 151
3 28 152 95
3 95 152 120
3 95 120 1
3 152 36 120
3 13 50 151
3 151 50 116
3 151 116 36
3 50 8 116
3 6 103 66
3 66 103 153
3 66 153 18
3 103 30 153
3 18 153 155
3 155 153 154
3 155 154 35
3 153 30 154
3 18 155 63
3 63 155 121
3 63 121 11
3 155 35 121
3 30 105 154
3 154 105 119
3 154 119 35
3 105 1 119
3 7 97 57
3 57 97 156
3 57 156 15
3 97 27 156
3 15 156 158
3 158 156 157
3 158 157 40
3 156 27 157
3 15 158 55
3 55 158 131
3 55 131 9
3 158 40 131
3 27 90 157
3 157 90 136
3 157 136 40
3 90 2 136
3 6 71 104
3 104 71 159
3 104 159 31
3 71 21 159
3 31 159 161
3 161 159 160
3 161 160 41
3 159 21 160
3 31 161 100
3 100 161 137
3 100 137 2
3 161 41 137
3 21 73 160
3 160 73 135
3 160 135 41
3 73 10 135
"""

# write geometry as off file
f = open("geodesic.off", "w")
f.write(GEODESIC_STR)
f.close()

# read geometry as off file
f = open("geodesic.off", "r")
l = f.readline()
l = f.readline()

ls = l.split()
n_vertex = int(ls[0])
n_facet  = int(ls[1])

vertex = np.zeros((n_vertex,3))
for ii in range(n_vertex):
    vertex[ii] = np.array([float(x) for x in f.readline().split()])

poly  = []
for ii in range(n_facet):
    ls = f.readline().split()
    v1 = vertex[int(ls[1])]
    v2 = vertex[int(ls[2])]
    v3 = vertex[int(ls[3])]

    poly.append(np.array([v1, v2, v3]))
f.close()


# now, let's randomly choose 1000 direction (rays)
# you can adapt this part for your own purpose
rays = np.random.rand(1000, 3)*2. - 1
for r in rays : # normalize all rays
    r /= np.linalg.norm(r)

# ok, now, count for each ray, the geode's triangle which intersects the ray
count = np.zeros(n_facet, dtype=np.int64)
for r in rays:
    for ii in range(n_facet):
        t = ray_triangle_intersect(r, poly[ii][2], poly[ii][1], poly[ii][0])
        if t >= 0:
          count[ii] += 1
    for ii in range(n_facet):
        t = ray_triangle_intersect(-r, poly[ii][2], poly[ii][1], poly[ii][0])
        if t >= 0:
          count[ii] += 1

# just for checking that verything is going well during the collision detection
if (np.sum(count) != len(rays)*2):
    print("ERROR", np.sum(count), len(rays))
    sys.exit()

# now, we will apply a factor to the geode facet (for increasing / decreasing spherical bars)
for ii in range(n_facet):
    poly[ii] *= count[ii]

# and, finally display the results with mayavi 
fig = mlab.figure( bgcolor=(0., 0., 0.))
visual.set_viewer(fig)
MAX = np.max(count)

# parse each geode's facet
for ii in range(n_facet):   
    a  = np.array([0.])
    x0 = poly[ii][:,0]
    y0 = poly[ii][:,1]
    z0 = poly[ii][:,2]
    
    x = np.concatenate((a, x0))
    y = np.concatenate((a, y0))
    z = np.concatenate((a, z0))

    n = count[ii]
    t = np.array([0.,n,n,n])
    mlab.triangular_mesh(x, y, z, [(0, 1, 2),(0, 1, 3),(0, 2, 3),(1, 2, 3)],
                         line_width=10., scalars=t,tube_radius=2, representation="surface", vmin=0., vmax=MAX)

# add arrows for x,y,z directions
a=visual.Arrow(x=0,y=0,z=0, color=(1,0,0))
a.length_cone=0.2
a.axis = [1, 0, 0]
a.actor.scale=[MAX*1.5, MAX*1.5, MAX*1.5]
mlab.text3d(MAX*1.6, 0., 0., "X", scale=(5, 5, 5))

b=visual.Arrow(x=0,y=0,z=0, color=(0,1,0))
b.axis = [0, 1, 0]
b.actor.scale=[MAX*1.5, MAX*1.5, MAX*1.5]
mlab.text3d(0., MAX*1.6, 0., "Y", scale=(5, 5, 5))


c=visual.Arrow(x=0,y=0,z=0, color=(0,0,1))
c.axis = [0, 0, 1]
c.actor.scale=[MAX*1.5, MAX*1.5, MAX*1.5]
mlab.text3d(0., 0., MAX*1.6, "Z", scale=(5, 5, 5))

mlab.scalarbar()
mlab.show()


